#include <hmg.ch>
#include 'hbclass.ch'

Procedure Main
	local osolitario := solitario():inicio()
	
	osolitario:activar()

Return

Class solitario
	Data Tema
	Data aClick
	Data aItem
	Data aControles
	Data aObjetos
	Data Imagen_muerto	
	Method inicio() constructor
	Method activar() 
	Method etiqueta_click(n)
	Method traspaso( a, b )
	Method pintar()
	Method carga_items()
	Method crea_objetos()
	Method busca_control( f, c )
	Method finalizar()
	
End Class

Method Inicio class solitario
	::Tema			:= 1
	::aClick		:= {0,0}
	::aItem			:= {}
	::aControles	:= {}
	::aObjetos		:= {}
	::Imagen_muerto	:= getCurrentFolder()+'\temas\blank.png'
Return self

Method activar class solitario
	
	::carga_items()
	
	Load Window Main
	Main.Center
	Main.Activate

Return

Method busca_control( f, c ) class solitario
	local i:= 1, npos := 0
	
	for i= 1 to len( ::aControles )
		do events
		if ::aControles[i]:Fila = f .and. ::aControles[i]:Columna = c
			npos = i
			exit
		Endif
	Next			
	
return npos

method etiqueta_click( nitem ) class solitario
	local lMover := .f.                    
	local Control0, Control1, Control2
	local npos :=0
	
		
	* 1= origen
	* 2= destino
	If ::aclick[1] = 0
		::aclick[1] = nItem
		Return
	Endif
	
	If ::aclick[2] = 0
		::aclick[2] = nitem
	Endif	
	
	* si son iguales se vacia.
	If ::aclick[1] = ::aclick[2] 
		::aclick = { 0, 0 }
		Return
	Endif
		
	Control1	= ::aControles[ ::aClick[1] ]
	Control2	= ::aControles[ ::aClick[2] ]
	
	
	* generar las posibilidades
	aposibilidades := {}
	
	* Si intenta mover el cuadro vacio a la ficha no lo procesa y devuelve
	if ! Control1:Vivo
		::aclick = { 0, 0 }
		return
	Endif
	
	* Si intenta mover sobre otro control vivo tampoco procesa y devuelve
	If Control2:Vivo
		::aclick = { 0, 0 }
		return
	Endif
	
	* arriba	
	if Control1:Fila - 2 = Control2:Fila
		if Control1:Columna = Control2:Columna				
			npos := ::busca_control( Control1:Fila-1, Control1:Columna )
			if nPos > 0
				Control0 = ::aControles[ npos ]
				* si intenta pasar sobre una celda vacia tampoco se puede
				if Control0:Vivo
					lMover := .T.
				Endif
			Endif
		endif
	endif
			
	
	* derecha
	if Control1:Fila = Control2:Fila
		if Control1:Columna+2 = Control2:Columna
			npos := ::busca_control( Control1:Fila, Control1:Columna+1 )
			if nPos > 0
				Control0 = ::aControles[ npos ]
				if Control0:Vivo
					lMover := .T.
				Endif
			Endif
		endif
	endif
	
	*abajo
	if Control1:Fila+2 = Control2:Fila
		if Control1:Columna = Control2:Columna
			npos := ::busca_control( Control1:Fila+1, Control1:Columna )
			if nPos > 0
				Control0 = ::aControles[ npos ]
				if Control0:Vivo
					lMover := .T.
				Endif
			Endif
		endif
	endif
	
	* izquierda
	if Control1:Fila = Control2:Fila
		if Control1:Columna-2 = Control2:Columna
			npos := ::busca_control( Control1:Fila, Control1:Columna-1 )
			if nPos > 0
				Control0 = ::aControles[ npos ]
				if Control0:Vivo
					lMover := .T.
				Endif
			Endif
		endif
	endif

			
	If lMover

		* cambio los colores de las celdas.
		::Traspaso( ::aClick[1], ::aClick[2], Control0:orden )
		
	else
		msginfo('No')
						
	endif
	
	::aclick := {0,0}

return

Method traspaso( a, b, c ) class solitario
	Local xColor	:= ::aControles[a]:Imagen
	Local Vivo := ::aControles[a]:Vivo
	* a = vivo, b =muerto, c=vivo
	* a = muerto, b = vivo, c =muerto
	::aControles[a]:Imagen	:= ::aControles[b]:Imagen
	::aControles[a]:Vivo	:= ::aControles[b]:Vivo
	::aControles[a]:Pintar()
	
	::aControles[b]:Imagen	:= xColor
	::aControles[b]:Vivo	:= Vivo
	::aControles[b]:Pintar()
	
	::aControles[c]:Imagen	:= ::imagen_muerto
	::aControles[c]:Vivo	:= .f.
	::aControles[c]:Pintar()
	
return nil

Method pintar class solitario
	local cControl := "", cPicture := ""
	local i := 0
	
	::Tema := main.combo_1.value
	For i= 1 to Len( ::aControles )
		do events
		::aControles[i]:Finalizar()
	Next
	
	::aControles := {}
	::crea_objetos()
	
	For i= 1 To len( ::aControles )
		Do Events
		::aControles[i]:Pintar()
	Next
	
return

Method carga_items class solitario
	local aDir := directory(getCurrentFolder()+'\temas\*.*')
	local i := 1
	
	For i= 1 to len( adir )
		Do Events
		if lower(adir[i][1]) != 'blank.png'
			aadd( ::aitem, adir[i][1] )
		endif
	Next
	
return

Method crea_objetos class solitario
	local i := 1, r := 1, j := 1, n := 0, c := 0
	local o
	local cImagen := getCurrentFolder()+'\temas\'+::aitem[ ::tema ]
	for i= 1 to 7
		Do Events
		n = if( ( i >= 3 .and. i <= 5 ), 7, 3 )
		c = if( n = 3, 3, 1 )
		for j= 1 to n
			Do Events
			o := Celda():nuevo()
			o:nombre	:= 'image_'+alltrim(str(r))
			o:fila		:= i
			o:columna	:= c
			o:vivo		:= .t.
			o:imagen	:= cimagen
			o:orden		:= r
			aadd( ::aControles, o )
			r ++
			c ++
		next
	next
	::aControles[ 17 ]:Vivo := .F.
	::aControles[ 17 ]:Imagen:= ::imagen_muerto
return

Method finalizar class solitario
	release ::Tema, ::aClick, ::aItems
return nil

Class Celda
	Data Nombre
	Data Fila
	Data Columna
	Data Vivo
	Data imagen
	Data orden
	
	Method Nuevo() Constructor
	Method Finalizar()
	Method pintar()		inline setProperty('main', ::Nombre, 'picture', ::imagen )
	Method cadena_propiedades()
End class

Method Nuevo() class celda
	::nombre	:= ""
	::imagen	:= ""
	::fila		:= 0
	::columna	:= 0
	::Vivo		:= .f.
	::orden		:= 0
Return Self

Method Finalizar() Class Celda
	::nombre	:= nil
	::imagen		:= nil
	::fila		:= nil
	::columna	:= nil
	::Vivo		:= nil
	::orden		:= nil
Return nil

Method cadena_propiedades class celda
	local cTexto := ""
	cTexto += "<----------------------------------------->"
	cTexto += "nombre 	: "+::nombre+hb_osnewline()
	cTexto += "fila 	: "+str(::fila)+hb_osnewline()
	cTexto += "columna 	: "+str(::columna)+hb_osnewline()
	cTexto += "vivo 	: "+if(::vivo, '.t.', '.f.')+hb_osnewline()
	cTexto += "imagen 	: "+::imagen+hb_osnewline()
	cTexto += "orden	: "+str(::orden)+hb_osnewline()
	cTexto += "<----------------------------------------->"
return cTexto
	
